#include "SPI.h"

#if SPI_MODE == 0
	void SPI_Delay(u8 cnt)
	{
		while(cnt--);
	}

	void SPI_Init(void)
	{
		CS		= 1;		// ѡж
		MISO	= 1;
		WP		= 1;
		MOSI	= 1;
		SCLK	= 0;		// SPIģʽ0SCLKʼ͵ƽ
		
	}

	void SPI_WriteByte(u8 dat)	// дһֽ
	{
		u8 i;
		for(i=0; i<8; i++)
		{
			if(dat & 0x80)
			{
				MOSI = 1;
			}
			else
			{
				MOSI = 0;
			}
			SCLK = 1;			// ½
			SPI_Delay(3);
			SCLK = 0;
			dat <<= 1;
		}
	}

	u8 SPI_ReadByte(void)	// ȡһֽ
	{
		u8 i;
		u8 dat=0;
		
		for(i=0; i<8; i++)
		{
			dat <<= 1;
			SCLK = 1;
			SPI_Delay(3);
			if(MISO)
			{
				dat |= 1;
			}
			SCLK = 0;
		}
		return dat;
	}
	
#elif SPI_MODE == 1
	
	void SPI_Init(void)
	{
		P_SW1 &= 0xF3;		// 1111 0011 ʼ
		P_SW1 |= 0x04;		// 0000 0100
		
		// SPCTL = 0x90 SPCTL SPR λ 00 ޷ȡ
		SPCTL = 0x91;		// ģʽ 1001 0001
		SPCTL |= 0x40;
		
		SCLK = 0;			// ųʼ
		
		SPIF = 1;			// ձ־λ
		WCOL = 1;
	}

	void SPI_WriteByte(u8 dat)	// дһֽ
	{
		SPDAT = dat;
		while(SPIF == 0);
		SPIF = 1;			// ձ־λ
		WCOL = 1;
	}

	u8 SPI_ReadByte(void)	// ȡһֽ
	{
		SPI_WriteByte(0x44);
		return (SPDAT);
	}


// ģʽ£24Mʧ 11M
#elif SPI_MODE == 2

	void SPI_Init(void)
	{
		P_SW3 &= 0xF3;
		P_SW3 |= 0x04;
		
		SCON = 0x10;
		USARTCR1 = 0x10;
		USARTCR4 = 0x01;
		USARTCR1 |= 0x08;
	}

	void SPI_WriteByte(u8 dat)	// дһֽ
	{
		TI = 0;
		SBUF = dat;
		while(!TI);
	}

	u8 SPI_ReadByte(void)	// ȡһֽ
	{
		TI = 0;
		SBUF = 0x44;
		while(!TI);
		return SBUF;
	}

#endif